from __future__ import annotations
import re
from typing import Callable, Literal
from typing_extensions import TypeAlias
from rst_fast_parse.core import gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_, gAAAAABmvnuPraSvzPr_j2lP7deGTfZusFG7XOVfOBNt_WXSsl_7CxjK1L5ZQh7lRtszllDG4Rb8iUhMCWjDhTgtHlDbOeqrWw__, gAAAAABmvnuPFiNsglZcNLAYt_CC2O1ysbl1SSMD2FRbUir08R6GhJ4_pHfdyZfFLoDODeMiuyT4FlxtDHsHs7Ap_zeSPfIJEoFJExTwUxoIYnI_IhBKuSQ_, gAAAAABmvnuPPyMQkQupnqgLmhaaFYgOZLGB_6PmYhq6Z7EFG7fvQIeBKPWZau_qy3_gK97GQaP9Y21Bt9xfJC2if5OtnVuBGw__
from rst_fast_parse.elements import ListElement, ListItemElement
from rst_fast_parse._hijklmn.bbbbbbbb import gAAAAABmvnuPw_24UycpZHZ0SnNZDMDijrarWTvlcygs0RqwAOnaekH67zwl0sh6WbAZpalqdy9rfbuAoF9_IaN15t2I3i5Dzg__
from rst_fast_parse._vwxyz import gAAAAABmvnuP_quFKpuYPWz7QdJ1kBaRmIwCQe9rCmHuVZv5Jk1eR82v8o4s8FimCtSYne_H63sWt2aoyl93LrLoAS2foR6HAA__
from rst_fast_parse._opqrstu.ccccffff import gAAAAABmvnuPrsG27_5WLGDs9MOj7eehnuuaCG1u10_HXmxyjCyP2Fq1AGxdyvgksHBIfjAqt8Jp9ic5_m6H_jEOy0xVwD7SEHduR2LtPYqsmPXtv7n1RKE_
from rst_fast_parse._opqrstu.ccccgggg import gAAAAABmvnuPq5N8JGA4oWiT9CmQU1R8NkKBTRdvMZn42kVEBjInI82JtINYq53ozGQDESWYRdU7YxFMGHKQpDIlHsHpNLke1Q__

def gAAAAABmvnuPF6bVAZxCI6HP8YyAiaHM5_2XVdTCXTV_iqxaOPY4BBRMAiMhE0q2s0aTHznSeHWDUuRaj3fDA_h_wEheJoFqgHApYUgwZSwwQh6HR16zS1k_(gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__: gAAAAABmvnuP_quFKpuYPWz7QdJ1kBaRmIwCQe9rCmHuVZv5Jk1eR82v8o4s8FimCtSYne_H63sWt2aoyl93LrLoAS2foR6HAA__, gAAAAABmvnuPYt9DzGdqMfWNOuwtjka8ZGGeiS1LNy4wgzgDfvlIIqW4pT1dYg5y16iqq00IY__pqD108UHZ2GboK_DTuHleHg__: gAAAAABmvnuPPyMQkQupnqgLmhaaFYgOZLGB_6PmYhq6Z7EFG7fvQIeBKPWZau_qy3_gK97GQaP9Y21Bt9xfJC2if5OtnVuBGw__, diagnostics: gAAAAABmvnuPFiNsglZcNLAYt_CC2O1ysbl1SSMD2FRbUir08R6GhJ4_pHfdyZfFLoDODeMiuyT4FlxtDHsHs7Ap_zeSPfIJEoFJExTwUxoIYnI_IhBKuSQ_, gAAAAABmvnuPXL6Emfi0cADtfUUxyGFAW96485SpVObSx2qWfRnKviy8cAA6gsm7ycdF5KRIIkAezNtiTSd80LC6nJ4rmtLAPA__: gAAAAABmvnuPraSvzPr_j2lP7deGTfZusFG7XOVfOBNt_WXSsl_7CxjK1L5ZQh7lRtszllDG4Rb8iUhMCWjDhTgtHlDbOeqrWw__, /) -> gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_:
    if (init_line := gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__) is None:
        return gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_.gAAAAABmvnuPRbdlsfvazMgv6xfcLvNC0QmLZyLevZAFSsO0gN3crEdWh85I5fK4AkyiRNRbEPJDXyQKddWPenhSD_uYCxVoJg__
    if (result := gAAAAABmvnuPvpMf_Mvm6dHVDVYtYpHMyuENfMkhDQuMNhJb_79ueSF26cMWaT9KAz_EwaH3loAhlTHyKNqnOHXtIMxLG06UeBd5F6XO_C2LSqXEbxh0NIw_(init_line.content)) is None:
        return gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_.gAAAAABmvnuPMhZZtYqBwgmlntAnk2pNEzm4IuBVbAOgcNUNPk5cwtS0ORGVXbj_bY3x708WqH8FacqCobgWvhXy_PI3HCP44A__
    init_format, init_type, init_ordinal, _ = result
    last_auto = init_type == 'auto'
    last_ordinal: int | None = None
    if init_type == 'auto':
        init_type = 'arabic'
    if (next_line := gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPuZXbXRIn_Z6uW7rl1b6tjkrw7FbiBfqZUZMylVWsCG9X6PO5txqGZgMgnn879eyop15Pa9oKq7BJnPqu2HDIpA__()) and (not next_line.gAAAAABmvnuPPkZGuVG7rySsIzxg5qGN25cViT_kH2yqB1Jh4YgWuHYFeCggnKOC9aN7z3D2A8_1OQHaFV7ltGyYeMGtrldIWg__) and next_line.content[:1].strip() and (not gAAAAABmvnuPvpMf_Mvm6dHVDVYtYpHMyuENfMkhDQuMNhJb_79ueSF26cMWaT9KAz_EwaH3loAhlTHyKNqnOHXtIMxLG06UeBd5F6XO_C2LSqXEbxh0NIw_(next_line.content)):
        return gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_.gAAAAABmvnuPMhZZtYqBwgmlntAnk2pNEzm4IuBVbAOgcNUNPk5cwtS0ORGVXbj_bY3x708WqH8FacqCobgWvhXy_PI3HCP44A__
    items: list[ListItemElement] = []
    while (gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__ := gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__):
        if gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__.gAAAAABmvnuPPkZGuVG7rySsIzxg5qGN25cViT_kH2yqB1Jh4YgWuHYFeCggnKOC9aN7z3D2A8_1OQHaFV7ltGyYeMGtrldIWg__:
            gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPp_QE9_WnXWVDZg5oKVJ6LQ5CVrdrh1cxtPKUkZZB8K9_AZTE7wd9z5Ah21eEusDJcgxVmRcYg1wa0BtlMgWtfg__()
            continue
        if (result := gAAAAABmvnuPvpMf_Mvm6dHVDVYtYpHMyuENfMkhDQuMNhJb_79ueSF26cMWaT9KAz_EwaH3loAhlTHyKNqnOHXtIMxLG06UeBd5F6XO_C2LSqXEbxh0NIw_(gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__.content, init_type)) is not None:
            eformat, etype, next_ordinal, char_offset = result
            if eformat != init_format or (etype != 'auto' and (etype != init_type or last_auto or (last_ordinal is not None and next_ordinal != last_ordinal + 1))):
                gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPpiwYWIWH21eukoUsu8_dek_kurDmTm7MXy7hVTAfOZnzJUthCdp3ApDmUhoxh1lCcR9AN0Wo_pHiFBmaeEHHtA__()
                break
            if len(gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__.content) > char_offset:
                content = gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPOjFYx9CukvAlFG4IkqEY8TiMaHLiFnphgpaWKjU7jUp5Xmhfeb0JqIJIaOPP3ORvVlVsp416WYrX7EjjSluJWFGGzZQxh2oDHZzL9j05lhI_(char_offset, always_first=True, advance=True)
            else:
                content = gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuP7GYlBpyUMoBwe7_TunDc2_4uc29ah_BnEOCTXMP36oquCGO87r3iZjbChrmxPWCG4zdHc_1_NLP2mdqYNiLEPGwYP19x8fzhtNuYHwrbX00_(first_indent=char_offset, advance=True)
            list_item = ListItemElement((gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__.line, gAAAAABmvnuPYx_1AJ_ZlGlgvDrehH2B_nIHaCPrE9fnl6NCy1IGzbJUFbt_A6ls0oN30yko4kcNJOnUTmBis7jsENh0h5ePEw__.line if content.gAAAAABmvnuPtSk5A9h7uoFTW9kQc_J179me2SXQYV0xfUAjl9qCaFt0mzEf2Um6Ld_aFscHpO2rxlifxEZAlIVBvvMQKO5aMg__ is None else content.gAAAAABmvnuPtSk5A9h7uoFTW9kQc_J179me2SXQYV0xfUAjl9qCaFt0mzEf2Um6Ld_aFscHpO2rxlifxEZAlIVBvvMQKO5aMg__.line))
            items.append(list_item)
            gAAAAABmvnuPXL6Emfi0cADtfUUxyGFAW96485SpVObSx2qWfRnKviy8cAA6gsm7ycdF5KRIIkAezNtiTSd80LC6nJ4rmtLAPA__.gAAAAABmvnuP1hvd_xfelN0N_WmyWGU1_7YIza4ZHl1631JbvqrNe9vLA3R6rrcW__PCVWxVAPdE_I6Bm2Bj4BwrOaODaF5DrQ__(content, list_item, diagnostics)
            last_auto = etype == 'auto'
            last_ordinal = next_ordinal
            gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPp_QE9_WnXWVDZg5oKVJ6LQ5CVrdrh1cxtPKUkZZB8K9_AZTE7wd9z5Ah21eEusDJcgxVmRcYg1wa0BtlMgWtfg__()
        else:
            gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__.gAAAAABmvnuPpiwYWIWH21eukoUsu8_dek_kurDmTm7MXy7hVTAfOZnzJUthCdp3ApDmUhoxh1lCcR9AN0Wo_pHiFBmaeEHHtA__()
            break
    if items:
        gAAAAABmvnuPYt9DzGdqMfWNOuwtjka8ZGGeiS1LNy4wgzgDfvlIIqW4pT1dYg5y16iqq00IY__pqD108UHZ2GboK_DTuHleHg__.append(ListElement('enum_list', items))
        gAAAAABmvnuPrsG27_5WLGDs9MOj7eehnuuaCG1u10_HXmxyjCyP2Fq1AGxdyvgksHBIfjAqt8Jp9ic5_m6H_jEOy0xVwD7SEHduR2LtPYqsmPXtv7n1RKE_(diagnostics, gAAAAABmvnuPgOUfWLYnhgj_rZE4eyrpzmgA4RGoTLKXgRLXDrHsLiZCW02GShxQcPj1_ZEQnz4C9__S7bV35h8f_PETntG5SQ__, 'Enumerated list')
    return gAAAAABmvnuPNj42qdtIY8ySbUt8SHVpmQrQOLSobwLPYoj3RvNC1jY9pcO0EYhdFzdD_cMsPYESBwfRJcjrzDXWF59zSMUltg2pgUJdIA6tNFRc2rxItPQ_.gAAAAABmvnuP_ClUFKNcZK3izoScss_N4ceBj9LXWkx42Msjc8XGvV8pQ0jcSFPd7BXVi3Qh2svvdS7_7MW5pdxsyUOXMvFZBw__
_ParenType: TypeAlias = Literal['parens', 'rparen', 'period']
_EnumType: TypeAlias = Literal['auto', 'arabic', 'loweralpha', 'upperalpha', 'lowerroman', 'upperroman']
gAAAAABmvnuPfAlfJETWCyT5Y1LKWKwwqKdgRej6ULseS7E7GV7ywB8hTBCKgU5CGNLjtg4DW1Tz22Y5lKimuM7P0B9p_accZeyuZqo_IU5PushOSDPypwM_: dict[_EnumType, tuple[str, _EnumType]] = {'auto': ('^[0-9]+$', 'arabic'), 'arabic': ('^[0-9]+$', 'arabic'), 'loweralpha': ('^[a-z]$', 'loweralpha'), 'upperalpha': ('^[A-Z]$', 'upperalpha'), 'lowerroman': ('^[ivxlcdm]+$', 'lowerroman'), 'upperroman': ('^[IVXLCDM]+$', 'upperroman')}
gAAAAABmvnuPyikfY_s5_BEhZF79QSd9bCsScSkuz7flbTNC2aoVyrdkvZWQqgd0HgzzD3gORL3CWDuSwd2ErbYeW6puUjlUIg__: tuple[tuple[str, _EnumType], ...] = (('^[0-9]+$', 'arabic'), ('^[a-z]$', 'loweralpha'), ('^[A-Z]$', 'upperalpha'), ('^[ivxlcdm]+$', 'lowerroman'), ('^[IVXLCDM]+$', 'upperroman'))
gAAAAABmvnuPgvKHjeMw19BL1cJpVedyDz0xuDvXHNS2MN_bt0nvvhLy7xm5p6EEgShXl6FClZEGVCyQ6eFileuNUXX5JmRO9Mm_pn0r0XsKUpV9RIrqFJw_: dict[_EnumType, Callable[[str], int | None]] = {'auto': lambda t: 1, 'arabic': int, 'loweralpha': lambda t: ord(t) - ord('a') + 1, 'upperalpha': lambda t: ord(t) - ord('A') + 1, 'lowerroman': lambda t: gAAAAABmvnuPq5N8JGA4oWiT9CmQU1R8NkKBTRdvMZn42kVEBjInI82JtINYq53ozGQDESWYRdU7YxFMGHKQpDIlHsHpNLke1Q__(t.upper()), 'upperroman': lambda t: gAAAAABmvnuPq5N8JGA4oWiT9CmQU1R8NkKBTRdvMZn42kVEBjInI82JtINYq53ozGQDESWYRdU7YxFMGHKQpDIlHsHpNLke1Q__(t)}

def gAAAAABmvnuPvpMf_Mvm6dHVDVYtYpHMyuENfMkhDQuMNhJb_79ueSF26cMWaT9KAz_EwaH3loAhlTHyKNqnOHXtIMxLG06UeBd5F6XO_C2LSqXEbxh0NIw_(line: str, expected: None | _EnumType=None) -> None | tuple[_ParenType, _EnumType, int, int]:
    if not (match := re.match(gAAAAABmvnuPw_24UycpZHZ0SnNZDMDijrarWTvlcygs0RqwAOnaekH67zwl0sh6WbAZpalqdy9rfbuAoF9_IaN15t2I3i5Dzg__, line)):
        return None
    fmt: _ParenType
    for fmt in ('parens', 'rparen', 'period'):
        if (submatch := match.group(fmt)):
            text: str = submatch[:-1]
            if fmt == 'parens':
                text = text[1:]
            break
    else:
        raise RuntimeError(f'enumerator format not matched: {line!r}')
    sequence: None | _EnumType = None
    if text == '#':
        sequence = 'auto'
    elif expected is not None:
        regex, result = gAAAAABmvnuPfAlfJETWCyT5Y1LKWKwwqKdgRej6ULseS7E7GV7ywB8hTBCKgU5CGNLjtg4DW1Tz22Y5lKimuM7P0B9p_accZeyuZqo_IU5PushOSDPypwM_[expected]
        if re.match(regex, text):
            sequence = result
    elif text == 'i':
        sequence = 'lowerroman'
    elif text == 'I':
        sequence = 'upperroman'
    if sequence is None:
        for regex, result in gAAAAABmvnuPyikfY_s5_BEhZF79QSd9bCsScSkuz7flbTNC2aoVyrdkvZWQqgd0HgzzD3gORL3CWDuSwd2ErbYeW6puUjlUIg__:
            if re.match(regex, text):
                sequence = result
                break
        else:
            raise RuntimeError(f'enumerator sequence not matched: {text!r}')
    if (ordinal := gAAAAABmvnuPgvKHjeMw19BL1cJpVedyDz0xuDvXHNS2MN_bt0nvvhLy7xm5p6EEgShXl6FClZEGVCyQ6eFileuNUXX5JmRO9Mm_pn0r0XsKUpV9RIrqFJw_[sequence](text)) is None:
        return None
    return (fmt, sequence, ordinal, match.end(0))